# `@toptal/davinci-bootstrap`

Bootstraps scaffolding/skeleton applications or parts of the monorepo with everything necessary and according to Toptal guidelines to start working as soon as possible.

## Usage

Use it by installing `yarn add @toptal/davinci` in your project.

### Creates new SPA application

Creates a new app according to Toptal guidelines in directory `app-name` and installs all dependencies (including `davinci` and `picasso`). Prepares app so you can just run `yarn start` and application will open in browser.

`davinci new {app-name}`

Arguments:

- `app-name`
  
  The name of the application

### Creates new monorepo application

Creates a new monorepo application according to Toptal guidelines in the directory `/apps/${app-name}` or in `/domains/${domain-name}/apps/${app-name}` if `domain-name` is specified.

`davinci new-app {app-name}`

Arguments:

- `app-name`
  
  The name of the application

- `--domain={domain-name}`

  Domain name. By default `domain-name` is empty, this will create application
  in the root `/apps` folder. If `domain-name` is specified - in `/domains/${domain-name}/apps` folder.

### Creates new monorepo library

Creates a new monorepo library according to Toptal guidelines in the directory `/libs/${lib-name}` or in `/domains/${domain-name}/libs/${lib-name}` if `domain-name` is specified.

`davinci new-lib {lib-name}`

Arguments:

- `lib-name`
  
  The name of the library

- `--domain={domain-name}`

  Domain name. By default `domain-name` is empty, this will create library
  in the root `/libs` folder. If `domain-name` is specified - in `/domains/${domain-name}/libs` folder.

### Alias

In all the commands you can use `davinci-bootstrap` directly if needed, instead of `davinci`. This is not a recommended way to use `davinci`, but in very rare cases it might be useful.

### IDE Tooling

This package can be used directly in your IDE through these extensions

- [IntelliJ Suite (WebStorm, RubyMine, IDEA)](https://github.com/zaguiini/intellij-davinci-plugin)
- [VSCode](https://github.com/borisyordanov/vscode-supercharge-react)


### Development

If you want to test locally the generation of a new app - you can run

```
node ./davinci/packages/bootstrap/bin/davinci-bootstrap.js new [app-name]
```

and a new application will be generated in `[app-name]` directory.
